/***************************************************************************
 *            uart.c
 *
 *  Sun Jun  4 01:02:26 2006
 *  Copyright  2006  User
 *  Email
 ****************************************************************************/

#include <avr/pgmspace.h>
#include <avr/io.h>
#include <stdio.h>
#include "uart.h"

static FILE mystdout = FDEV_SETUP_STREAM(sendchar , NULL, _FDEV_SETUP_WRITE);

void uart_init(unsigned char DIVI )
	{
		/* USART-Init 9600 Baud bei 8MHz für Mega32 */
		UCSRB |= ( 1 << TXEN );							// UART TX einschalten
		UCSRC |= ( 1 << URSEL )|( 3<<UCSZ0 );	        // Asynchron 8N1
		UBRRH  = 0;                                   	// Highbyte ist 0
		UBRRL  = DIVI;                                 	// Lowbyte ist 51 ( dezimal )
		stdout = &mystdout;
	}

void sendchar( unsigned char Zeichen )
	{
		while (!(UCSRA & (1<<UDRE)));
		UDR = Zeichen;
	}

void putstring( unsigned char *string )
	{
    	while ( *string )
    	{ 
        	sendchar( *string );
        	string++;
    	}
	}

void putbuffer( unsigned int bufferlen ,unsigned char *buffer)
	{
		unsigned int i;
		for ( i = 0 ; i < bufferlen ; i++)
    	{ 
        	sendchar( buffer[i] );
    	}
	}
