/***************************************************************************
 *            network.c
 *
 *  Fri Sep  1 10:20:31 2006
 *  Copyright  2006  User
 *  Email
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include "network.h"

unsigned int Network_init( unsigned int Options )
	{
	
		// Welcher mode ist für Netzwerk gewählt ?
		if ( ( Options & IRQMODE ) == IRQMODE )
		{
			EthernetInit( INTERRUPTMODE ); // ethernet init mit IRQ
		}
		else
		{
			EthernetInit( POLLINGMODE ); // ethernet init mit Polling
		}
			
		// init des TCP-Stack, eigentlich wird nur der Timeout-Handler registriert beim Timer1 und dann 1 mal
		// die Sekunde aufegrufen, um hängende Verbindungen zu beenden
		tcp_init();
		
		// Wenn das Bit für DHCP gesetzt ist, mach mal DHCP :-)
		if ( ( Options & DHCP ) == DHCP ) DHCP_GetConfig();
		
		// Wenn Bit für NTP gesetzt ist, mach mal NTP
		if ( ( Options & NTP ) == NTP ) NTP_GetTime();
		
	}
